/*
  CHRegistration.h
  Fontcase
  
  Created by Pieter Omvlee on 23-8-07.
  Copyright 2007 BohemianCoding. All rights reserved.
*/

#import <Cocoa/Cocoa.h>
#import "CHApplicationAdditions.h"
#import "CHSheetController.h"
#import "CHPurchaseItem.h"
#import "CHRegistrationFunctions.h"
#import "CHLicensorDelegateProtocol.h"

#define EURO 0x20AC

@interface CHRegistration : CHSheetController
{
  IBOutlet NSTextField *licenseField;
  
  IBOutlet NSTextField *firstTitle;
  IBOutlet NSTextField *firstSubtitle;
  
  IBOutlet NSButtonCell *license1;
  IBOutlet NSButtonCell *license2;
  IBOutlet NSButtonCell *license3;
  IBOutlet NSButtonCell *license4;
  
  IBOutlet NSTextField *license1Subtitle;
  IBOutlet NSTextField *license2Subtitle;
  IBOutlet NSTextField *license3Subtitle;
  IBOutlet NSTextField *license4Subtitle;
  
  IBOutlet NSTextField *thanksMessage;
  
  IBOutlet NSView *view1;
  IBOutlet NSView *view2;
  IBOutlet NSView *view3;
  
  IBOutlet NSButton *button1;
  IBOutlet NSButton *button2;
  IBOutlet NSButton *button3;
  
  IBOutlet NSBox *topBox;
  
  id dataSource;
}
@property (assign) id dataSource;


- (IBAction)confirm:(id)sender;
- (IBAction)cancel:(id)sender;
- (IBAction)registerAction:(id)sender;
- (IBAction)buy:(id)sender;
- (IBAction)lostLicense:(id)sender;

- (IBAction)goToFirstView:(id)sender;
- (IBAction)goToSecondView:(id)sender;
- (IBAction)goToThirdView:(id)sender;

@end

@interface NSCalendarDate (RegistrationExtensions)
- (NSCalendarDate *)dateByAddingDays:(int)days;
@end
