/*
 CHRegistrationFunctions.h
 Fontcase
 
 Created by Pieter Omvlee on 18-01-08.
 Copyright 2007 BohemianCoding. All rights reserved.
 */

#import <Cocoa/Cocoa.h>
#import "CHApplicationAdditions.h"

FOUNDATION_STATIC_INLINE NSString *CHLicensePath()
{
  return [[NSString stringWithFormat:@"~/Library/Application Support/.%@",[[NSApp valueForKey:@"abbreviatedAppName"] lowercaseString]] stringByExpandingTildeInPath];
}

static BOOL _isLicensed = NO;

FOUNDATION_STATIC_INLINE BOOL CHIsLicensed()
{
  if (_isLicensed)
    return YES;
  
  NSString *path              = CHLicensePath();
  NSFileManager *fileManager  = [NSFileManager defaultManager];
  NSMutableString *newPath    = [NSMutableString string];
  
  int i, x;
  if ([fileManager fileExistsAtPath:path]) {
    NSArray *array = [NSArray arrayWithContentsOfFile:CHLicensePath()];
    for (i=0; i<[array count]; i++) {
      x = [[array objectAtIndex:i] intValue];
      x = ( x - 8) / 3;
      [newPath appendFormat:@"%c",x];
    }
    _isLicensed = [newPath isEqual:CHLicensePath()];
    return _isLicensed;
  } else
    return NO;
}

FOUNDATION_STATIC_INLINE BOOL CHWriteLicense()
{
  NSString *path        = CHLicensePath();
  NSMutableArray *array = [NSMutableArray array];
  
  int i = 0;
  for (i=0; i<[path length]; i++) {
    int x = [path characterAtIndex:i];
    x = (x * 3) + 8;
    [array addObject:[NSNumber numberWithInt:x]];
  }
  
  return [array writeToFile:CHLicensePath() atomically:YES];  
}

FOUNDATION_STATIC_INLINE BOOL CHCheckServerAnswer (NSString *answer, NSString *licenseKey)
{
  if ([answer isEqual:@"NO"])
    return NO;
  
  NSArray *contents = [answer componentsSeparatedByString:@";"];
  int checkSum      = [[contents lastObject] intValue];
  int i;
  int sum = 0;
  for (i=0; i<[licenseKey length]; i++) sum += [licenseKey characterAtIndex:i];
  
  return (sum+2 == checkSum);
}

FOUNDATION_STATIC_INLINE BOOL CHLicense(NSString *licenseKey)
{
  NSString *app     = [NSApp performSelector:@selector(abbreviatedAppName)];
  NSString *version = [NSApp performSelector:@selector(majorVersion)];
  
  NSString *string  = [NSString stringWithFormat:@"http://www.bohemiancoding.com/activate.php?app=%@%@&sn=",app,version];
  NSURL *url        = [NSURL URLWithString:[string stringByAppendingString:licenseKey]];
//  NSURL *url        = [NSURL URLWithString:[@"http://www.bohemiancoding.com/activate.php?app=fontcase1&sn=" stringByAppendingString:licenseKey]];
  NSString *answer  = [NSString stringWithContentsOfURL:url encoding:NSUTF8StringEncoding error:NULL];
  
  BOOL validAnswer = CHCheckServerAnswer(answer, licenseKey);
  if (validAnswer)
    CHWriteLicense();
  
  return validAnswer;
}
